
'use strict';
/*updated by qiangran in 20170628
    主要修改点：
    1 增加可配置的背景图 bgImg
    2 增加插入的祖先级标签类 wrapperClassName
*/

var $ = require('common:widget/lib/jquery/jquery');
require('./mask.scss');

let html = '<div class="dialog-mask">'+
        '<div class="dialog-mask-box">'+
            '<header></header>'+
            '<a class="dialog-mask-close"></a>'+
            '<section></section>'+
            '<footer></footer>'+
        '</div>'+
        '<div class="dialog-mask-bg"></div>'+
    '</div>';

/*
*  @title: {string} 标题
*  @content: {obj/string}  内容
*  @btn: {arr} 按钮,可传多个
*  @closeColor: {css} 关闭按钮的样式
*  @className: {css} 当前弹窗的样式
*  @success: {fn} 按钮自定义执行函数
*/

let mask = {
    init(args){
        let $el = $(html);
        let opt = {
            box: $el.find('.dialog-mask-box'),
            title: $el.find('header'),
            content: $el.find('section'),
            footer: $el.find('footer'),
            close: $el.find('.dialog-mask-close')
        };


        $('body').bind('touchmove',function(e){
            if( !$(e.target).parents('.dialog-mask-box').length){
                e.preventDefault();
            }
        });

        if(args.bgImg){
            opt.box.css({
                'background': `url(${args.bgImg}) no-repeat `,
                'background-size': '100% 100% ',
            });
        };

        if( args.title ){
            opt.title.html( args.title );
        }else{
            opt.title.css({
                height : 0
            });
        }

        if( args.content ){

            if(typeof(args.content) == 'string'){
                opt.content.html(args.content);
            }else{
                opt.content.append( args.content );
                args.content.show();
            }
        }else{
            opt.content.hide();
        }

        if( args.className ){
            $el.addClass( args.className );
        }

        if( args.btn ){
            let btnHtml = '';
            for(let i = 0; i< args.btn.length; i++){
                btnHtml += '<a class="dialog-mask-button">'+ args.btn[i] +'</a>';
            }
            opt.footer.html(btnHtml);

            if(args.btn.length == 2){
                opt.footer.addClass('two');
            }

        }else{
            opt.footer.hide();
        }

        if( args.closeColor ){
            opt.close.addClass(args.closeColor);
        }

        if(args.success){
            args.success.call(this);
        }else{
            opt.footer.find('a').on('click',function(){
                $(this).parents('.dialog-mask').hide();
                $('body').unbind('touchmove');
            });
        }
         if(args.wrapperClass){


            $el.appendTo(args.wrapperClass);
         }else{
            $el.appendTo('body');
        }


        $el.show();

        opt.box.css({
            'margin-top': -opt.box.innerHeight()/2
        });

        opt.close.bind('click',function(){
            $(this).parents('.dialog-mask').hide();
            $('body').unbind('touchmove');
        });

    }
};

module.exports = mask;


