/**
 * 页面的各种埋点统计, 屏蔽掉第三方服务的细节
 * Created by jess on 2016/12/22.
 */


const $ = require('common:widget/lib/jquery/jquery.js');
const glpbCommon = require('glpb-components-common');
const BaseComponent = glpbCommon.BaseComponent;
const utils = BaseComponent.utils;

const weStatistic = glpbCommon.weStatistic;


///////////////////  页面定义部分   ////////////
const commonPage = require('./pages/common.js');
const homePage = require('./pages/home.js');
const exchangePage = require('./pages/exchange.js');
const lpPage = require('./pages/lp.js');


///////////////////   事件定义部分  /////////////
const formEvents = require('./events/form.js');




let pageList = [ commonPage, homePage, exchangePage, lpPage ];
let eventList = [ formEvents ];

for( let i = 0, len = pageList.length; i < len; i++ ){
    weStatistic.addPage(pageList[i]);
}

for( let j = 0, length = eventList.length; j < length; j++ ){
    weStatistic.addEvent(eventList[j]);
}


//暴露到全局, 需要在 page builder 组件里访问
window.weStatistic = weStatistic;

module.exports = weStatistic;


