/**
 * 微信SDK
 * Created by 王半仙 on 16/6/16.
 * update by qiangran in 2017/05/18
 * moved by qiangran on 2018/04/19
 */


'use strict';
let WXShareDataConfig = require('./wxShareDataConfig.js');
var service = require('../../service/service-factory.js');
const signatureService = service.getService('passport');

class WXSdk {

      /** 通过老的mobile  获取signature 即将废弃*/
      getWXSdkPromise(url, type){
          return signatureService.getWxSignature({
              refererUrl : url,
              type : type
          });
      }
     /** 通过node的mobile  获取signature*/
     getWXSdkPromiseFromNode(url, type){
        return signatureService.getWxSignatureFromNode({
            refererUrl : url,
            type : type
        });
     }


    share(signaturePackage, wxShareData, readyCallback){
        wx.config(signaturePackage);
        wx.ready(function (){
            wxShareData = WXShareDataConfig.mergeShareDate(wxShareData);
            wx.onMenuShareAppMessage(wxShareData);
            wx.onMenuShareTimeline(wxShareData);
            wx.onMenuShareQQ(wxShareData);
            wx.onMenuShareWeibo(wxShareData);
            if( typeof readyCallback === 'function' ){
                readyCallback( wx, wxShareData );
            }

        });

        wx.error(function(error){

            console.log(error);
        });
    }
}

WXSdk.wx = window.wx;
let  single = new WXSdk();
module.exports =   single;