/**
 * 返回顶部组件
 * add by wangwei in 2019-04-18
 **/

const glpbCommon = require('glpb-components-common');

const BaseComponent = glpbCommon.BaseComponent;
const $ = BaseComponent.$;

require('./back-to-top.scss');


const BackToTop = BaseComponent.extend(
    {
        componentName : 'glpb-com-glpb_we_com_back_to_top',
        componentNameZh : '返回顶部按钮',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.MOBILE,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                width : '1.06rem',
                height: '1.24rem',
            };
        },

        getDefaultData : function(){
            return {
                "bgImageUrl_$$comment" : '背景图【图片必须为宽高等比】',
                bgImageUrl : 'https://s0.renrendai.com/cms/5864b3f0c5ee7210913f6796/0207xiaoshuo/float.png',
                "durationToTop_$$comment" : '滚动多少像素显示按钮',
                durationToTop: 300,
                "bottom_$$comment" : '按钮距底部距离',
                bottom : '100px',
            };
        },

        init : function(){
            //当前Ajax请求的ID
            this.querySign = null;
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
            this.scrollCallBack = this.scrollCallBack.bind( this );
        },

        scrollCallBack: function(){
            let data = this.data || {};
            let durationToTop = data.durationToTop || 300;
                if ($(window).scrollTop() > durationToTop){
                    $(".glpb-com-glpb-com-glpb_we_com_back_to_top").show();
                } else {
                    $(".glpb-com-glpb-com-glpb_we_com_back_to_top").hide();
                }
        },

        backTopHandle(){
            if ($(".register-phone:visible").length) {
                $(".register-phone").focus();
            } else {
                $('body,html').animate({
                    scrollTop: 0
                }, 500);
                console.log('[ERROR]: 未找到注册组件Input元素');
            }
          },
      

        bindComponentEvent: function(){
            if(this.isProductionMode() && ! this.eventBinded){
                $(window).on('scroll', this.scrollCallBack);
                this.$el.on('click', this.backTopHandle);
                this.eventBinded = true;
            }
        },

        componentWillUnmount: function(){
            if(this.eventBinded){
                $(window).off('scroll', this.scrollCallBack);
            }
            this.$el = null;
        },

        render : function(){
            let data = this.data || {};
            let style = this.style || {};
            let tpl = `<div class="glpb-mobile-back-top" style="bottom:${data.bottom}"><img src=${data.bgImageUrl} style="width: ${style.width}; height: ${style.height}"/></div>`
            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-content', $el);
            this.$el = $el;
            this.$content = $content;
            if( ! this.isProductionMode() ){
                this.$el.css('display', 'block')
            }
        },

    }
);


module.exports = BackToTop;