/**
 * 双下载按钮
 * Created by daifei on 2019/4/22
 */


const glpbCommon = require('glpb-components-common');


const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const utils = BaseComponent.utils;

const download = require('../../common-ui/downapp/downapp.js')

require('./double-download-btn.scss');

//默认配置
let configData;

const downloadUrl = {
    "loan":{
        "android" : "https://at.umeng.com/XX9Xfm",
        "ios" : "https://at.umeng.com/Gb8DCC"
    }
};

const downloadSourceUrl = {
    "bdwxpztgapp-1": 'https://loan.renrendai.com/androidApk/rrd_baidu-pz.apk',
    "360wxpztgapp-1": 'https://loan.renrendai.com/androidApk/rrd_360-pz.apk',
    "smwxpztgapp-1": 'https://loan.renrendai.com/androidApk/rrd_shenma-pz.apk',
    "sgwxpztgapp-1": 'https://loan.renrendai.com/androidApk/rrd_sougou-pz.apk',
};

let tpl = `<div class="glpb-content"></div>`;

const DoubleButton = BaseComponent.extend(
    {
        componentName : 'glpb_double_download_button',
        componentNameZh : '双下载按钮',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.MOBILE,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                height : '0.98rem',
                fontSize : '0.3rem',
                lineHeight : '0.98rem',
                width:'100%',
                zIndex:1,
                position:'fixed',
                left:0,
                bottom:0

            };
        },

        //支持直接下载或者跳转到下载页面
        getDefaultData : function(){
            return {
                'left_button_text_$$comment':'左边的按钮文字',
                left_button_text:'下载投资APP',
                'left_button_href_$$comment':'左边的按钮跳转链接，没有链接就直接跳转应用宝',
                left_button_href:'',

                'right_button_text_$$comment':'右边的按钮文字',
                right_button_text:'下载借款APP',
                'right_button_href_$$comment':'右边的按钮跳转链接，没有链接就直接跳转应用宝',
                right_button_href:'',


                'one_textalign_$$comment':'左边按钮的字体对齐方式',
                one_textalign:'center',
                'one_color_$$comment':'左边按钮的字体颜色',
                one_color:'#fff',
                'one_backgroundcolor_$$comment':'左边按钮的背景颜色',
                one_backgroundcolor:'#203d77',


                'two_textalign_$$comment':'右边按钮的字体对齐方式',
                two_textalign:'center',
                'two_color_$$comment':'右边按钮的字体颜色',
                two_color:'#fff',
                'two_backgroundcolor_$$comment':'右边按钮的背景颜色',
                two_backgroundcolor:'#fe7437',

            };
        },

        getDataType : function(){
            return BaseComponent.DATA_TYPES.JSON;
        },

        getData : function(){
            return this.data || {};
        },

        render : function(){
            let data = this.data;
            let style = this.style;


            let oneButton = `text-align:${data.one_textalign};color:${data.one_color};background-color:${data.one_backgroundcolor}`;
            let twoButton = `text-align:${data.two_textalign};color:${data.two_color};background-color:${data.two_backgroundcolor}`;


            tpl = `<div class="glpb-double-button">
                    <div class="left-button" style="${oneButton}">${data.left_button_text}</div>
                    <div class="right-button" style="${twoButton}">${data.right_button_text}</div>
                </div>`;


            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass );


            this.$el = $el;
            this.$content = $el;

            configData = this.getData();

            this.updateCSSStyle( cssStyle );

            this.setData( data );

        },

        updateCSSStyle : function(cssStyle){
            this.styleManager.update( '#' + this.componentId , cssStyle );

        },

        bindComponentEvent : function(){

            let that = this;

            if( this.isProductionMode() && ! this.eventBinded ){

                this.eventBinded = true;
                const data = this.data;
                this.$content.on('click','.left-button', function(){
                    if(data.left_button_href){
                        location.href = data.left_button_href;
                    }else{
                        download.downloadApp();
                    }
                });
                //我要借款点击事件
                this.$content.on('click', '.right-button', function(){

                    const userAgent = navigator.userAgent || '';
                    let isAndroid = userAgent.indexOf('Android') > -1 || userAgent.indexOf('Adr') > -1;
                    let isIOS = !!userAgent.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);


                    if(data.right_button_href){
                        location.href = data.right_button_href;
                    }else{
                        if(isAndroid){
                            const ccName = utils.getSearchConf().ccName || '';
                            let url = downloadSourceUrl[ccName];
                            if (!url) {
                                url = 'https://loan.renrendai.com/androidApk/rrd_brand.apk';
                            }
                            location.href = url;
                        }else if(isIOS){
                            location.href = downloadUrl.loan.ios;
                        }else{
                            alert("不支持该设备！");
                        }
                    }
                });

            }
        },

        componentWillUnmount : function(){
            if( this.eventBinded ){
                //this.$content.off('click', function(){download.downloadApp(); });
            }
            this.$content = null;
        }
    }
);


module.exports = DoubleButton;

