/**
 * 置底注册组件
 * Created by wcq on 2018-11-1.
 */

const glpbCommon = require('glpb-components-common');

require('./fixed-register-btn.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

let debounceTimer = null;

const scale = document.documentElement.clientWidth / 750;

function onScroll() {
    //clearTimeout(debounceTimer);
    //debounceTimer = setTimeout(function(){
        if ($(window).scrollTop() > 600 * scale && $(".register-phone:visible").length ){
            //$("#registerButtonContainer").fadeIn(1);
            $("#registerButtonContainer").show();
        } else {
            //$("#registerButtonContainer").fadeOut(1);
            $("#registerButtonContainer").hide();
        }
   // }, 100)
};

function onClick() {
    if($(".register-phone:visible").length) {
       // let distance = $(".register-phone").offset().top || 0;
       // distance = distance - 140 * scale; // input距顶部距离750屏140
       // if(distance < 0) distance = 0;
       // $("body, html").animate({ scrollTop: distance }, 300);
        $(".register-phone").focus();
        //强隐藏底部跳转按钮[其实可以不要]
        $("#registerButtonContainer").hide();
    } else {
        //$("body, html").animate({ scrollTop: 0 }, 300);
        $("body, html").scrollTop(0);
        console.log('[ERROR]: 未找到注册组件Input元素')
    }
}

const FixedRegisterBtn = BaseComponent.extend(
    {
        componentName : 'glpb_fixed_bottom_register_button',
        componentNameZh : '置底注册组件',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.MOBILE,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                padding : '0',
                margin : '0'
            };
        },

        getDefaultData : function(){
            return {
                "btnBgColor_$$comment" : '按钮颜色',
                btnBgColor : 'linear-gradient(to top, #ff7f31, #ff9435)',
                "btnTextColor_$$comment" : '按钮文字颜色',
                btnTextColor : '#ffffff',
                "btnText_$$comment" : '按钮文案',
                btnText : '注册领1288新手券',

            };
        },

        init: function(){
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
        },

        render: function(){
            let data = this.data;

            const tpl = `<div class="glpb-content">
                            <div id="registerButtonContainer" style="display: none">
                                <div id="registerButton" style="background: ${data.btnBgColor}; color: ${data.btnTextColor}">${data.btnText}</div>
                            </div>
                        </div>`;

            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );;
            let $content = $('.glpb-content', $el);

            this.$el = $el;
            this.$content = $content;

            this.updateCSSStyle( cssStyle );
            this.setData( data );
        },

        

        bindComponentEvent: function(){
            if(this.isProductionMode() && ! this.eventBinded){
                $(window).on('scroll', onScroll);
                $('#registerButton').on('click', onClick);
                this.eventBinded = true;
            }
        },

        componentWillUnmount: function(){
            if(this.eventBinded){
                $(window).off('scroll', onScroll);
                $('#registerButton').off('click', onClick);
            }
            this.$content = null;
        }

    }
);


module.exports = FixedRegisterBtn;