/**
 * LP页面 注册框A/B Test 实验组二
 * Created by 王半仙 on 2018-05-07.
 */

const glpbCommon = require('glpb-components-common');

const glpbUtils = glpbCommon.utils;

const DataManager = require('../../common-ui/data-manager/data-manager.js');

const serviceFactory = require('../../service/service-factory.js');

const poup = require('../../common-ui/poup/poup.js');

const utils_web = require('../../common-ui/utils/utils.js');

const mask = require('../../common-ui/mask/mask.js');

const downApp = require('../../common-ui/downapp/downapp.js');

const statistic = require('../../common-ui/statistic/statistic.js');

const regService = serviceFactory.getService('lp');

const gt = require('common:widget/lib/gt/gt.js');

let validate = utils_web.formUtil;

require('./lp-register-group2.scss');

const rsaCrypt = glpbCommon.rsaCrypt;

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const utils = BaseComponent.utils;

const parameter = glpbCommon.parameter;

const Cookies = glpbCommon.Cookies;

const tpl = `<div class="glpb-fn-animate-item"><div class="glpb-content"></div></div>`;

const editorPlaceHolderImage = '//m.we.com/cms/5864b392e0286a10854d8766/register/lp/lp-register-group1.png';

let voiceCodeTimer;

let isVoice = 0; // 默认发送短信验证码

let captchaUrl = '/mo/passport/index/captcha?&_=' + (new Date().getTime());
const  imgCodeHtml = `<div class="form-group-item rand-code-box">
                        <input class="register-imgcode" name="imgcode" type="tel" placeholder="请输入图片验证码" />
                        <div class="img-rand-code-border">
                            <img class="img-rand-code rand-code-img" src=${captchaUrl} />
                        </div>
                      </div>`;

const tplConf = utils.getTplConf();
// 注册接口参数
let __registerOutParams = {};

const LandingPageHeader = BaseComponent.extend(
    {
        componentName : 'glpb_we_com_mo_lp_register_experimental_group2',
        componentNameZh : '注册框-实验组2',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.MOBILE,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultData : function(){
            return {
                intention : 'LENDER',
                regChannel : 'IOS',
                "page-key" : '诸葛IO统计关键词',
                pageKey :"moPbRegister",
                "from_$$comment" : '来源',
                from :"lp",
                "success_url_$$comment" : '注册成功后跳转的URL，必须是全地址,如果未配置此地址，则默认注册成功后展示下载弹窗popBgImg',
                success_url : "",
                "registerBoxBgColor_$$comment" : '注册框背景色，默认白色',
                registerBoxBgColor :"#fff",
                "registerBoxborder_$$comment" : '注册框border设置，默认不显示(设置则为 solid 1px 色值)',
                registerBoxborder :"none",
                "btnBgColor_$$comment" : '所有按钮的颜色',
                btnBgColor : 'linear-gradient( 90deg, rgb(198,48,51) 0%, rgb(210,53,56) 100%)',
                "btnTextColor_$$comment" : '所有按钮文字的颜色',
                "countDownTextColor_$$comment" : '发送短验文字颜色(倒计时)',
                countDownTextColor :"#c73134",
                btnTextColor : '#fff',
                "inputBgColor_$$comment" : '输入框背景色',
                inputBgColor : '#fff',
                "inputTextColor_$$comment" : '输入框文字色',
                inputTextColor : '#333',
                "submit01Text_$$comment" : '注册第一步按钮的文案',
                submit01Text : '注册领1288元新手券',
                "submit01BtnImage_$$comment" : '第一步按钮的背景图片URL,如果配置此字段，则btnBgColor颜色和submit01Text文本失效',
                submit01BtnImage : '',
                "submit01BtnWidth_$$comment" : '第一步注册按钮的宽度，仅在使用背景图时有效',
                submit01BtnWidth : '6.3rem',
                "submit01BtnHeight_$$comment" : '第一步注册按钮的高度，仅在使用背景图时有效',
                submit01BtnHeight : '1rem',
                "submit02Text_$$comment" : '注册第二步按钮的文案',
                submit02Text : '完成注册',
                "dialogSubmitText_$$comment" : '弹窗按钮文案',
                dialogSubmitText : '下载App，使用新手券',
                "clickDownloadCallBack_$$comment" : '点击下载后执行回调函数,true执行，false不执行,注:script标签里的函数名**必须**pbClickDownloadCallback',
                downloadCallBack: false,
                "hasCallBack_$$comment" : '注册成功后执行回调函数,true执行，false不执行,注:script标签里的函数名**必须**pbRegisterSuccessCallback',
                hasCallBack: false,
                "dialogBottomLinkText_$$comment": "弹窗按钮下的链接文案(不配置就不展示)",
                dialogBottomLinkText: '',
                "dialogBottomLinkTextColor_$$comment": "弹窗按钮下的链接文案的文字颜色",
                dialogBottomLinkTextColor: '#deac7d',
                "dialogBottomLinkHref_$$comment": "弹窗按钮下的链接地址",
                dialogBottomLinkHref: '',
                "voiceCodeDelay_$$comment": "语言验证码延迟几秒展示（默认30秒）",
                voiceCodeDelay: 30,
                "quitPopBg_$$comment": "阻止退出弹窗背景图(宽高: 705*616)",
                quitPopBg: "https://s0.renrendai.com/cms/5864b392e0286a10854d8766/common/confirm-exit-1113.png",
                "isQuitPopOpen_$$comment": "阻止弹窗是否开启 true开启 false关闭",
                isQuitPopOpen: false,
            };
        },

        getDefaultStyle : function(){
            return {
                padding : '0',
                margin : '0 auto'
            };
        },

        init : function(){

            //当前Ajax请求的ID
            this.querySign = null;
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;

            //风险测评开关
            this.riskSwitchStatus = false;
            //风险测评内容
            this.riskDetail = null;

            this._imgRandCode = this._imgRandCode.bind( this );
            this._checkPhone = this._checkPhone.bind( this );
            this._register = this._register.bind( this );
            this.handlePopstate = this.handlePopstate.bind( this );

            //当前发送短信的验证方式
            this.verifyType = 'noNeed';
            this._reSendPhoneCode = this._reSendPhoneCode.bind(this);

            let data = this.data;
            this.time = 60;//目前写死
            this.from = data.from;
            this.success_url = data.success_url;
            //this.utmSource = data.utmSource;
            //this.popBgImg = data.popBgImg;
            tplConf.pageKey = data.pageKey||'moPbRegister';

            window.alert = poup.prompts;

            //非编辑模式下，初始化极验
            if( this.isProductionMode() ){
                //获取极验配置数据
                this.getGeetestConfig();
            }

        },

        getGeetestConfig(){
            let _this = this;
            regService.geetestConfig().then(function(res){
                let out = res.data;
                window.geetestData = out.data;
                //是否初始化极验验证
                _this.initGt(geetestData);
            }).catch(function(err){
                console.log(err);
            });
        },

        render : function(){


            let currentComponentId = this.componentId;
            let data = this.data;

            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-content', $el);

            this.$el = $el;
            this.$content = $content;

            let registerBoxBgColor = data.registerBoxBgColor;
            let registerBoxborder = data.registerBoxborder;
            let submit01Text = data.submit01Text;
            let submit02Text = data.submit02Text;
            let dialogSubmitText = data.dialogSubmitText;
            let dialogBottomLinkText = data.dialogBottomLinkText;

            let countDownTextColor = data.countDownTextColor;
            let btnBgColor = data.btnBgColor;
            let btnTextColor = data.btnTextColor;
            let inputBgColor = data.inputBgColor;
            let inputTextColor = data.inputTextColor;
            let dialogBottomLinkTextColor = data.dialogBottomLinkTextColor;

            let submit01BtnImage = data.submit01BtnImage;
            let submit01BtnWidth = data.submit01BtnWidth;
            let submit01BtnHeight = data.submit01BtnHeight;
            let dialogBottomLinkHref = data.dialogBottomLinkHref;
            let quitPopBg = data.quitPopBg;
            //第一步按钮的样式
            let submit01BtnStyle = '';
            if( submit01BtnImage ){
                //使用背景图片
                //使用背景图片时，清楚掉按钮的文字
                submit01Text = '';
                submit01BtnStyle = `width: ${submit01BtnWidth}; height: ${submit01BtnHeight}; background: transparent url(${submit01BtnImage}) no-repeat scroll 0 0; background-size: 100% 100%;`;
            }else{
                //使用文字
                submit01BtnStyle = `background:${btnBgColor} ;color:${btnTextColor}`;
            }

            //输入框样式
            let inputStyle = `background:${inputBgColor}; color:${inputTextColor}`;

            // 阻止退出弹窗背景图样式
            let quitPopBgStyle = `background: url('${quitPopBg}') no-repeat center center; background-size: 100% auto;`;


            if( ! this.isProductionMode() ){
                //编辑模式, 显示一个图片占位
                $(`<img class="editor-place-holder-img" src="${editorPlaceHolderImage}" title="注册组件占位图片(非真实数据)" />`).appendTo( $content );
                this.$content.css({
                    'padding': 0
                });
            }else{

                let html = `<div class="register">
                                <div class="register-one fn-clear">
                                    <div class="form-group-item">
                                        <input class="register-phone" name="phone" type="tel" maxlength="11" placeholder="输入手机号" style="${inputStyle}"/>
                                    </div>
                                    <button class="check-phone button" style="${submit01BtnStyle}">${submit01Text}</button>
                                </div>
                                <div class="register-two fn-clear">
                                    <div class="form-group-item" id="verificationCode">
                                        <input class="register-phone-code" name="phoneCode" type="tel" placeholder="输入验证码" style="${inputStyle}"/>
                                        <a class="phone-rand-code" style="color: ${countDownTextColor};">重新发送<span>(60)</span></a>
                                    </div>
                                    <div class="voiceCode">
                                    <span class="voiceCodeActive">收不到验证码？点击接收  <span style="color: #2C66AB;" class="sendVoiceCode">语音验证码</span></span>
                                    <span class="voiceCodeDisable" style="display: none">语音验证码发送中，请注意接听来电</span>
                                    </div>
                                    <div class="form-group-item">
                                        <input class="register-password" name="password" type="password" placeholder="设置登录密码"  style="${inputStyle}"/>
                                        <P class="form-group-tips">8~16位数字和字母组合</P>
                                    </div>
                                    <button class="register-button button" id="register-button-${currentComponentId}" style="background:${btnBgColor} ;color:${btnTextColor}">${submit02Text}</button>
                                    <div class="register-agree">
                                        <span class="agree-btn">我已阅读并同意</span>
                                        <a href="/mo/agreement/contract/index/name/user.rrd_reg">《人人贷注册服务协议》</a>
                                        <a href="/mo/agreement/contract/index?name=user.rrd_privacy">《人人贷隐私权政策》</a>
                                    </div>
                                  
                                </div>
                        </div>

                        
                        <div class="fn-hide warm-spread-downapp-mask">
                            <article class="reg-download">
                                <div class="download-icon">
                                    <img src="//m.we.com/cms/5864b392e0286a10854d8766/register/lp/lp_success_icon.png">
                                </div>
                                <div class="download-tips">恭喜您，<span class="font-red">1288元</span>新手券已放至人人贷账户</div>
                                <a class="button-download-app" id="download">${dialogSubmitText}</a>
                                <a class="button-download-bottom-link" style="color:${dialogBottomLinkTextColor}" href="${dialogBottomLinkHref}">${dialogBottomLinkText}</a>
                            </article>
                        </div>
                        
                        <div class="fn-hide lp-register-modal-box">
                            <div class="modal-bg"></div>
                            <div class="modal-content">
                                <div class="had-register-modal-close-btn">
                                    <img src="//m.renrendai.com/cms/58660a17cb02a3105bff2da1/components/close-btn.png?t=20180115-01" alt="">
                                </div>
                                <div class="had-register-box">
                                    <img class="register-bg" src="https://s0.renrendai.com/cms/58647d50e0286a10854d875a/lp/rrd-logo.jpg">
                                    <p class="register-tip">此手机号已注册，请前往App登录</p>
                                    <button class="download-btn had-registered-modal-download-btn">前往人人贷财富App</button>
                                </div>
                            </div>
                        </div>
                        <div class="fn-hide">
                            <img src="//m.we.com/cms/5864b392e0286a10854d8766/register/lp/20180529/uncheck.png" />
                        </div>
                        
                        <div class="fn-hide lp-register-risk-modal-box">
                            <div class="modal-bg"></div>
                            <div class="modal-content">
                                <div class="risk-modal-title">风险揭示书</div>
                                <div class="risk-modal-detail">
                                    
                                </div>
                                <ul class="risk-modal-action fn-clear">
                                    <li class="risk-modal-cancel">放弃注册</li>
                                    <li class="risk-modal-sure">我知道了</li>
                                </ul>
                            </div>
                        </div>

                        <div class="fn-hide lp-register-stop-quit">
                            <div class="modal-bg"></div>
                            <div class="modal-content" style="${quitPopBgStyle}">
                                <ul class="stop-quit-action">
                                    <li class="stop-quit-stay">立即领取</li>
                                    <li class="stop-quit-leave">狠心放弃</li>
                                </ul>
                            </div>
                        </div>

`;

                this.$content.append( html ).show();
                this.$content.css({
                    'background': registerBoxBgColor,
                    'border': registerBoxborder
                });
            }

            //此处是修改footer的文字颜色
            $(".pb-lp-footer p,.pb-lp-footer .mobile").css({
                "color":"#ffffff"
            });
            //待老的LP弃用 此处可以废弃 将lp-footer的文字颜色改为 #ffffff
        },

        handlePopstate(event){
            const u = navigator.userAgent;
            const isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
            // 单独处理安卓微信浏览器
            const isAndroidWx = !isIOS && u.indexOf('MicroMessenger') > -1;
            // 判断是否注册完
            let isComplete = localStorage.isComplete;
            if(isComplete){
                return null;
            }
            if (event.state && event.state.target == "leaveStatus") {
                if(isAndroidWx){
                    // 微信浏览器执行reload
                    location.reload();
                }else {
                    this.showQuitModal();
                }
            }
        },

        // 回退到上一个页面
        handleGoBack(){
            history.go(-1);
            history.replaceState(null,'','');
        },

        bindComponentEvent : function(){

            let that = this;
            let data = this.data || {};

            this.$registerStep1 = this.$el.find('.register-one');
            this.$registerStep2 = this.$el.find('.register-two');

            this.$checkPhoneBtn =  this.$el.find('.check-phone');
            this.$registerPhoneInput =  this.$el.find('.register-phone');
            this.$registerPhoneCodeInput =  this.$el.find('.register-phone-code');
            this.$phoneRandCodeBtn =  this.$el.find('.phone-rand-code');
            this.$registerPasswordInput =  this.$el.find('.register-password');
            this.$registerBtn =  this.$el.find('.register-button');
            this.$registerAgree = this.$el.find('.register-agree');
            this.$agreeBtn = this.$el.find('.agree-btn');

            this.$hadRegisterModalCloseBtn = this.$el.find('.had-register-modal-close-btn');
            this.$hadRegisterModalDownloadBtn = this.$el.find('.had-registered-modal-download-btn');

            this._sendVoiceCode();

            if( this.isProductionMode() && ! this.eventBinded ){
                //正式环境才绑定事件, 并且Ajax请求
                this._imgRandCode();
                this._checkPhone();
                this._reSendPhoneCode();
                this._checkedAgree();
                this._register();
                this._riskInit();
            }

            // 将url中的mobile参数填入
            if( Object.prototype.hasOwnProperty.call(glpbUtils.getSearchConf(),'mobile') ){
                $('.register-phone').val(glpbUtils.getSearchConf().mobile);
            }

            //关闭手机号已注册弹窗
            this.$hadRegisterModalCloseBtn.on("click",function(){
                that.hideHadRegisterModal(".lp-register-modal-box");
            });

            this.$hadRegisterModalDownloadBtn.on('click',function () {
                downApp.downloadApp("openApp");
            });

            if(data.isQuitPopOpen){
                // 开关开启才执行
                //监听页面回退事件
                let _this = this;
                // 偷偷摸摸预加载
                let oImg = new Image();
                oImg.src = data.quitPopBg || '';

                const u = navigator.userAgent;
                const isIOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/);
                // 单独处理安卓微信浏览器
                const isAndroidWx = !isIOS && u.indexOf('MicroMessenger') > -1;
                localStorage.removeItem('isComplete');
                setTimeout(function(){
                    if (!history.state) {
                        history.replaceState({
                            target: 'leaveStatus'
                        }, document.title, '');
                        history.pushState({
                            target: 'FinalStatus'
                        }, document.title, '');
                    }else if(history.state.target == "leaveStatus" && isAndroidWx){
                        _this.showQuitModal();
                        history.replaceState( null , document.title, '');
                    }
                    window.addEventListener('popstate',_this.handlePopstate, false);
                },200)
            }

        },



        setData : function(data){
            this.data = $.extend( this.data, data );
        },

        componentWillUnmount : function(){
            this.querySign = null;
            this.$content = null;
        },

        //*****************************************************

        _sendVoiceCode() {
            // 发送语音验证码
            let _this = this;
            $(".sendVoiceCode").on('click', function() {
                isVoice = 1;
                _this._SendPhoneCode($("#verificationCode"));
            })
        },


        _checkPhone(){

            let _this = this;
            this.$checkPhoneBtn.on('click',function(){
                $(this).prop('disabled',true);
                isVoice = 0;
                _this._SendPhoneCode($(this));
            });
        },

        _regAgree( ){

            let checkinfo = true;

            if(this.$registerAgree.hasClass("unchecked")){
                checkinfo = false;
                alert("请选择同意用户注册协议")
            }else {
                checkinfo = true;
            }
            return checkinfo;
        },

        _checkedAgree(){
            let _this = this;
            this.$agreeBtn.on("click",function(){
                _this.$registerAgree.toggleClass("unchecked");
            });
        },

        //有极验验证时候发送的请求
        _sendGeetestVerification(verifData){
            let _this = this;

            let _bValid;

            let randCode = '';

            let mobile = _this.$registerPhoneInput;

            _bValid = true;
            _bValid = _bValid && validate.checkMobile(mobile);

            if(!_bValid){
                _this.$checkPhoneBtn.prop('disabled',false);
                //手机号格式错误
                statistic.eventRaw({
                    eventId : 'Show_false_number'
                });
                return;
            }

            //发送短信验证码
            let _isWeCom = tplConf._isWeCom;
            let channal = (_isWeCom == 'true') ? 'WE' :'RRD';
            regService.sendRegisterSms(verifData).then(function(res){
                let out = res.data;
                _this.$checkPhoneBtn.prop('disabled',false);
                if(out.status == 0){
                    _this.$registerStep1.hide();
                    _this.$registerStep2.show();

                    if(isVoice === 0) {
                        $(".voiceCode").hide();
                        setTimeout(() => {
                            // X秒后展示语音验证码
                            voiceCodeTimer && clearTimeout(voiceCodeTimer);
                            $(".voiceCodeActive").show();
                            $(".voiceCodeDisable").hide();
                            $(".voiceCode").show();
                        }, Number(_this.data.voiceCodeDelay) * 1000 || 30000);
                    }
                    if(isVoice === 1) {
                        $(".voiceCodeActive").hide();
                        $(".voiceCodeDisable").show();
                        voiceCodeTimer = setTimeout(() => {
                            $(".voiceCodeActive").show();
                            $(".voiceCodeDisable").hide();
                        }, 30000)
                    } else {
                        _this._timeOut();
                    }
                }else{
                    if( out.status === 131001 ){
                        //手机号已存在 状态码更改
                        //手机号已注册
                        _this.showHadRegisterModal(".lp-register-modal-box");
                        statistic.eventRaw({
                            eventId : 'Show_number_already_register'
                        });
                    }else if( out.status === 1 ){
                        alert(out.message);
                        //图形验证码错误
                        statistic.eventRaw({
                            eventId : 'Show_false_identifying_code'
                        });
                    }else{
                        alert(out.message);
                    }
                }
            }).caught(function(){
                alert("暂时无法提供服务");
            });
        },

        _SendPhoneCode($this){
            let _this = this;
            let inputBgColor = this.data.inputBgColor;
            let inputTextColor = this.data.inputTextColor;
            let _bValid;

            let randCode = '';

            let mobile = _this.$registerPhoneInput;

            _bValid = true;
            _bValid = _bValid && validate.checkMobile(mobile);

            if(!_bValid){
                $this.prop('disabled',false);
                //手机号格式错误
                statistic.eventRaw({
                    eventId : 'Show_false_number'
                });
                return;
            }

            if($('.register-imgcode').length){
                randCode = $('.register-imgcode').val();

                if(!randCode){
                    alert('请先输入图形验证码');
                    $this.prop('disabled',false);
                    statistic.eventRaw({
                        eventId : 'Show_input_identifying_code'
                    });
                    return;
                }

                //需要图形验证码的情况下，点击按钮
                statistic.eventRaw({
                    eventId : 'Click_register_button_2'
                });

            }else{

                // 不需要  图形验证码的情况下，点击按钮
                statistic.eventRaw({
                    eventId : 'Click_register_button_1'
                });
            }

            if(_bValid){
                //发送短信验证码

                let _isWeCom = tplConf._isWeCom;
                let channal = (_isWeCom == 'true') ? 'WE' :'RRD';

                regService.sendRegisterSms({
                    type: 'REGISTER',
                    mobile: mobile.val(),
                    randCode : randCode,
                    from: _this.from,
                    channal: channal,
                    origin :'LP-MOBILE',
                    isVoice: isVoice,
                }).then(function(out){
                    let data = out.data;
                    $this.prop('disabled',false);
                    switch (data.status){
                        case 0:
                            _this.$registerStep1.hide();
                            _this.$registerStep2.show();
                            if(!$this.hasClass('phone-code')){
                                $('.rand-code-box','.glpb-com-glpb_we_com_mo_lp_register_experimental_group2').remove();
                            }
                            if(isVoice === 0) {
                                $(".voiceCode").hide();
                                setTimeout(() => {
                                    // X秒后展示语音验证码
                                    voiceCodeTimer && clearTimeout(voiceCodeTimer);
                                    $(".voiceCodeActive").show();
                                    $(".voiceCodeDisable").hide();
                                    $(".voiceCode").show();
                                }, Number(_this.data.voiceCodeDelay) * 1000 || 30000);
                            }

                            if(isVoice === 1) {
                                $(".voiceCodeActive").hide();
                                $(".voiceCodeDisable").show();
                                voiceCodeTimer = setTimeout(() => {
                                    $(".voiceCodeActive").show();
                                    $(".voiceCodeDisable").hide();
                                }, 30000)
                            } else {
                                _this._timeOut();
                            }
                            break;
                        case 930002:
                        case 3230 :
                            if(!$('.register-imgcode').length){
                                $this.before(imgCodeHtml);
                                _this.verifyType = 'captcha';
                                //此处是修改验证码输入框颜色
                                $(".register-imgcode").css({
                                    "background":`${inputBgColor}`,
                                    "color": `${inputTextColor}`
                                });

                                _this._imgRandCode();
                            }
                            break;
                        case 930001:
                            //需要极验
                            _this.verifyType = 'geetest';
                            //弹出极验
                            _this.captchaObj.verify();
                            $('.rand-code-box','.glpb-com-glpb_we_com_mo_lp_register_experimental_group2').remove();
                            break;
                        default:
                            _this._reshImgRandCode();
                            $('.register-imgcode').val('');
                            if( data.status === 131001 ){
                                //手机号已存在 状态码更改
                                //手机号已注册
                                _this.showHadRegisterModal(".lp-register-modal-box");
                                statistic.eventRaw({
                                    eventId : 'Show_number_already_register'
                                });
                            }else if( data.status === 1 ){
                                alert(data.message);
                                //图形验证码错误
                                statistic.eventRaw({
                                    eventId : 'Show_false_identifying_code'
                                });
                            }else{
                                alert(data.message);
                            }
                            break;
                    }

                }).catch(function(err){
                    alert("暂时无法提供服务");
                });
            }
            // statistic.event({
            //     pageKey : tplConf.pageKey,
            //     eventId : 'formSendSmsCode'
            // });

        },

        _reSendPhoneCode(){
            let _this = this;
            this.$phoneRandCodeBtn.on('click',function(){
                if( !$(this).find('span').html().length ){
                    isVoice = 0;
                    _this._SendPhoneCode($(this).parent());
                }
            });
        },

        //获取query和cookie中的utm开头参数，query优先级高于cookie
        _getUtmParams(queryData){
            const queryParams = queryData || {};
            const cookieUtm = parameter.getAllUtmCookies() || {};
            const queryUtm = {};
            for(let key in queryParams){
                if(queryParams.hasOwnProperty(key)) {
                    if( /^(utm)/.test(key) ){
                        queryUtm[key] = queryParams[key];
                    }
                }
            }
            return {queryUtm, cookieUtm};
        },

        _register(){

            let _this = this;
            let data = this.data;
            let intention = data.intention;
            let regChannel = data.regChannel;
            // let utmSource = data.utmSource;
            //let popBgImg = data.popBgImg;

            let _bValid;
            let mobile = _this.$registerPhoneInput ,
                randCode = _this.$registerPhoneCodeInput,
                pwd = _this.$registerPasswordInput,
                registerBtn = _this.$registerBtn ,
                registerAgree = _this.$registerAgree ;

            registerBtn.on('click',function(){

                _bValid = true;
                _bValid = _bValid && validate.checkMobile(mobile);

                if( _bValid ){
                    let randCodeValid = validate.checkRandCode(randCode);

                    if( _bValid && ! randCodeValid ){
                        //未输入短信验证码
                        statistic.eventRaw({
                            eventId : 'Show_false_short_message_number'
                        });
                    }

                    _bValid = _bValid && randCodeValid;
                }

                if( _bValid ){
                    let passwordValid = validate.checkPassWord(pwd,'密码格式错误，请设置8~16位数字和字母组合密码');

                    if( _bValid && ! passwordValid ){
                        //密码格式错误
                        statistic.eventRaw({
                            eventId : 'Show_pssword__false'
                        });
                    }

                    _bValid = _bValid && passwordValid;
                }

                _bValid = _bValid && _this._regAgree(registerAgree);


                // let params = utils.query2json(location.search);

                let queryData = parameter.getQueryData();
                queryData.mobile =  mobile.val();
                queryData.nickName = '';
                queryData.password =  rsaCrypt(pwd.val());
                queryData.smscode =  randCode.val();
                queryData.regChannel =  regChannel;
                queryData.intention =  intention;
                // queryData.utmSource =  utmSource;

                //console.log("=========queryData.utmSource========"+queryData.utmSource);
                //console.log("=========this.pageKeye========"+tplConf.pageKey,);

                //获取utm相关参数
                const utmParams = _this._getUtmParams(queryData);
                let outParams = {
                    coParams:queryData,
                    promotionUrl: window.promotionUrl || '',
                    forwardingUrl: window.forwardingUrl || '',
                    utmParams,
                };


                if(_bValid){

                    //判断是否展示风险测评弹窗
                    if(_this.riskSwitchStatus){
                        $('.risk-modal-title').text(_this.riskDetail.title || '风险揭示书');
                        $('.risk-modal-detail').html(_this.riskDetail.body || '');
                        __registerOutParams = outParams;
                        $('.lp-register-risk-modal-box').show();
                        $('.modal-content','.lp-register-risk-modal-box').css({
                            'marginTop': -$('.modal-content','.lp-register-risk-modal-box').height()/2 + 'px'
                        });
                    }else {
                        _this._submitRigister(outParams);
                    }
                }


            });
        },

        _submitRigister(outParams){
            let _this = this;
            regService.doRegister(outParams).then(function(out){
                let data = out.data;
                //data.status = 0;
                if(data.status == 0){
                    _this._extend(_this.from);
                    statistic.event({
                        pageKey : tplConf.pageKey,
                        eventId : 'formRegisterSuccess',
                        extra : {
                            'url' : location.href
                        },
                        callback : function(){
                            //等到诸葛IO统计发送成功后,再调用回调
                            _this._regSuccess();
                        }
                    });

                    //注册成功
                    statistic.eventRaw({
                        eventId : 'Show_register_success'
                    });

                    if(_this.data.isQuitPopOpen){
                        //注册成功去掉退出阻止弹窗
                        localStorage.isComplete = true;
                        window.removeEventListener('popstate',_this.handlePopstate, true);
                        window.addEventListener('popstate',_this.handleGoBack, true);
                    }

                    //可能注册成功的时候，会给第三方统计发送，具体的函数在page builder里，挂在 window 下面
                    if(_this.data.hasCallBack){
                        try{
                            let pbRegisterSuccessCallback = window.pbRegisterSuccessCallback;
                            if(typeof pbRegisterSuccessCallback === 'function'){
                                pbRegisterSuccessCallback({
                                    mobile : outParams.coParams.mobile,
                                    nickName : outParams.coParams.nickName
                                });
                            }
                        }catch (e){}
                    }

                }else{
                    alert( data.message );
                    if( data.status === 3219 ){
                        //短信验证码错误
                        statistic.eventRaw({
                            eventId : 'Show_false_short_message_number'
                        });
                    }else{
                        //统计通用错误信息
                        statistic.eventRaw({
                            eventId : 'formRegisterFail',
                            extra : {
                                'msg' : data.message
                            }
                        });
                    }
                    // statistic.event({
                    //     pageKey : tplConf.pageKey,
                    //     eventId : 'formRegisterFail',
                    //     extra : {
                    //         '失败原因' : data.message
                    //     }
                    // });
                }
            })
                .catch(function(e){
                    alert( e.message );

                });

            //点击 完成注册  按钮
            statistic.eventRaw({
                eventId : 'Click_done_register_button'
            });
        },

        _riskInit(){
            //风险提示初始化
            let that = this;
            regService.riskSwitchStatus().then( ( result ) => {
                let rsp = result.data;
                if( rsp.status === 0 ){
                    that.riskSwitchStatus = rsp.data.display;
                }else {
                    alert(result.message || '网络异常，稍后再试')
                }

            })
                .catch( (e) => {
                    alert(e.message || '网络异常，稍后再试');
                });
            //获取风险提示弹窗内容
            regService.riskContentStatus().then( ( result ) => {
                let rsp = result.data;
                if( rsp.status === 0 ){
                    that.riskDetail = rsp.data;
                }else {
                    alert(result.message || '网络异常，稍后再试')
                }

            })
                .catch( (e) => {
                    alert(e.message || '网络异常，稍后再试');
                });

            $('.risk-modal-cancel').on('click',function () {
                $('.lp-register-risk-modal-box').hide();
            });
            $('.risk-modal-sure').on('click',function () {
                $('.lp-register-risk-modal-box').hide();
                that._submitRigister(__registerOutParams);
            });
        },


        _regSuccess(){
            if(this.success_url){
                this._regSuccessToUrl();
            }else{
                this._regSuccessToPop();
            }
        },

        _regSuccessToPop(){
            //let popBgImg = this.popBgImg;
            let _this = this;

            mask.init({
                className: 'warm-spread-mask',
                content:  $('.warm-spread-downapp-mask'),
                wrapperClass:".glpb-com-glpb_we_com_mo_lp_register_experimental_group2", //mask插入的页面标签处
            });
            $('.button-download-app','.reg-download').on('click',function () {
                if(_this.data.downloadCallBack){
                    try{
                        let pbClickDownloadCallback = window.pbClickDownloadCallback;
                        if(typeof pbClickDownloadCallback === 'function'){
                            pbClickDownloadCallback();
                        }
                    }catch (e){ console.log(e) }
                }

                downApp.downloadApp();
                //点击 去下载
                statistic.eventRaw({
                    eventId : 'Click_domnload_button'
                });
            });
            //新增百度统计
            _hmt.push(['_trackPageview', '/*/success']);

        },

        _regSuccessToUrl : function(){

            let url_Suc = this.success_url;

            let symbol = url_Suc.indexOf('?') >= 0 ? '&' : '?';

            url_Suc += symbol + `from=${this.from}`;

            window.location.href = url_Suc;
        },

        _imgRandCode(){
            let _this = this;
            $('.rand-code-img').on('click',function(){
                _this._reshImgRandCode();
            });
        },

        _reshImgRandCode(){
            let url = '/mo/passport/index/captcha';
            url += '?&_=' + ( new Date() ).getTime();
            $('.rand-code-img').attr('src', url);
        },

        _timeOut(){
            let time = this.time;
            let iTimer = null;
            let _this = this;
            let countDownTextColor = this.data.countDownTextColor;
            _this.$phoneRandCodeBtn.addClass('countdowning');
            _this.$phoneRandCodeBtn.css({
                color: '#bbb'
            });
            iTimer = setInterval(function(){
                if(time > 1){
                    time--;
                    _this.$phoneRandCodeBtn.find('span').html('('+ time +')');
                }else{
                    _this.$phoneRandCodeBtn.find('span').html('');
                    _this.$phoneRandCodeBtn.removeClass('countdowning');
                    _this.$phoneRandCodeBtn.css({
                        color: countDownTextColor
                    });
                    clearInterval(iTimer);
                }
            },1000);
        },
        /*渠道推广*/
        _extend(from){

            //民生lp
            if( from == 'MingShengLP'){
                _taq.push({convert_id:"55490215376", event_type:"form"});
            }

        },

        // 手机号已注册弹窗
        showHadRegisterModal(modalId){
            $(modalId).show();
        },

        // 隐藏已注册弹窗
        hideHadRegisterModal(modalId){
            $(modalId).hide();
        },

        // 劝退弹窗
        showQuitModal(){
            $('.lp-register-stop-quit').show();

            $('.stop-quit-stay','.lp-register-stop-quit').on('click',function(){
                $('.lp-register-stop-quit').hide();
            });
            $('.stop-quit-leave','.lp-register-stop-quit').on('click',function(){
                history.go(-1);
                $('.lp-register-stop-quit').hide();
            })
        },

        //*************************************极验*************************************

        //极验验证 初始化
        initGt(geetestData){
            // 调用 initGeetest 进行初始化
            // 参数1：配置参数
            // 参数2：回调，回调的第一个参数验证码对象，之后可以使用它调用相应的接口
            initGeetest({
                // 以下 4 个配置参数为必须，不能缺少
                gt: geetestData.gt,
                challenge: geetestData.challenge,
                offline: !geetestData.success, // 表示用户后台检测极验服务器是否宕机
                new_captcha: geetestData.new_captcha, // 用于宕机时表示是新验证码的宕机

                product: "bind", // 产品形式，包括：float，popup
                pure : 1,//1 表示纯净无loading  0表示有loading
                // 更多配置参数说明请参见：http://docs.geetest.com/install/client/web-front/
            }, this.handler.bind(this));
        },

        //极验验证 初始化 回调函数
        handler(captchaObj){

            this.captchaObj = captchaObj;
            let that = this;
            captchaObj.onReady(function () {
                //alert('ready');
            })
            captchaObj.onNextReady(function(){
                //alert('next ready');
            })
            captchaObj.onClose(function(){
                //alert('close');
            })
            captchaObj.onError(function(){
                //alert('error');
                captchaObj.reset();
            })
            captchaObj.onSuccess(function () {
                //$('.loading-img').hide();
                let result = captchaObj.getValidate();
                if (!result) {
                    alert('请完成验证');
                    return ;
                }

                let _isWeCom = tplConf._isWeCom;
                let channel = (_isWeCom == 'true') ? 'WE' :'RRD';

                let verifData = {
                    type: 'REGISTER',
                    channel : channel,
                    from: that.from,
                    origin :'LP-MOBILE',
                    isGeetest: true,
                    mobile : that.$registerPhoneInput.val(),
                    geetest_challenge: result.geetest_challenge,
                    geetest_validate: result.geetest_validate,
                    geetest_seccode: result.geetest_seccode,
                    isVoice: isVoice
                }
                that._sendGeetestVerification(verifData);

            });
        },
    }
);


module.exports = LandingPageHeader;
