/**
 * MP4 视频组件
 * daifei
 */
const glpbCommon = require('glpb-components-common');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const tpl = `<div class="glpb-video-item"><div class="glpb-content"></div></div>`;

require('./lp-video-box.scss');
const VideoBox = BaseComponent.extend(
    {
        componentName : 'glpb_we_com_mo_lp_video_box',
        componentNameZh : 'VIDEO视频组件',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.MOBILE,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                width : '7.5rem',
                height : '4.25rem',
                background : {},
                padding : '0',
                margin : '0 auto'
            };
        },
        getDefaultData : function(){
            return {
                "mp4Url_$$comment" : '视频的地址',
                mp4Url : '',
                "mp4Poster_$$comment" : '视频封面，没有播放时显示的图片',
                mp4Poster : '',
            };
        },
        render : function(){
            let currentComponentId = this.componentId;
            let data = this.data;

            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );
            let $content = $('.glpb-content', $el);


            this.$el = $el;
            this.$content = $content;

            //这个方法在基类 里面实现了  不需要重新定义了
            this.updateCSSStyle(cssStyle);

            let mp4Poster = data.mp4Poster;
            let mp4Url = data.mp4Url;

            let video = $(`<video src="${mp4Url}" controls preload="metadata" poster="${mp4Poster}"></video>`);

            video.appendTo( $content );

            this.$video = video;
        },
        setData : function(data){
            this.data = $.extend( this.data, data );
            this.updateVideo();
        },
        updateVideo : function(){
            let data = this.data;
            this.$video.attr('src', data.mp4Url).attr('poster', data.mp4Poster);
        },

    }


);

module.exports = VideoBox;