/**
 * 分享按钮
 * Created by qiangran on 2018/04/19.
 */



const glpbCommon = require('glpb-components-common');

const serviceFactory = require('../../service/service-factory.js');

const lpService = serviceFactory.getService('lp');

const bridgeXXX = require('@we-fe/rrd-bridge');

const WXSdk = require('../../common-ui/wx/wxsdk.js');

require('./mgm-share-btn.scss');

const BaseComponent = glpbCommon.BaseComponent;

const $ = BaseComponent.$;

const utils = BaseComponent.utils;

const tpl = `<div class="glpb-fn-animate-item"><div class="glpb-content"></div></div>`;

const editorPlaceHolderImage = '//m.we.com/cms/5864b392e0286a10854d8766/pb/to_share_button.png';


let shareData = {};



function initShare(){

    if( bridgeXXX.isInWeAPP() ) {
        bridgeXXX.setShareData( [shareData.img_url] );
    }else{

        let refererUrl = location.href.split('#')[0];
        //使用服务号
        let wxType = 'public';
        WXSdk.getWXSdkPromiseFromNode(refererUrl, wxType)
            .then( (signatureResult) => {
                if(signatureResult.data.status == 0){
                    WXSdk.share(signatureResult.data.data, shareData);
                }else{
                    console.log("signature请求失败!");
                }
            })
            .catch( (error) => {
                console.log(error);
            });
    }

}

function showModal(modalId){
    $( modalId ).removeClass('fn-hide');
    $( '.modal-box' ).removeClass('fn-hide');
    $( '.modal-bg' ).removeClass('fn-hide');
}

function callShareModal(){
    if(bridgeXXX.isInWeAPP()){
        bridgeXXX.share( shareData );
    }else{
        showModal('#wx-share');
    }
}

function jumpLoginPage(){
    if( bridgeXXX.isInWeAPP() ) {
        bridgeXXX.showLoginPage();
    }else{
        let href = location.href;
        if(href){
            href = encodeURIComponent(href)
        }
        window.location.href = `/wap/passport/index/login?returnUrl=${href}`;
    }
}

function toShare(isLogin){
    if( !isLogin ){
        jumpLoginPage();
        return;
    }

    callShareModal();

}


const MgmShareBtn = BaseComponent.extend(
    {
        componentName : 'glpb_mgm_share_button',
        componentNameZh : 'MO-分享按钮',
        componentCategory : BaseComponent.CATEGORY.UI,
        platform : BaseComponent.PLATFORM.MOBILE,
        canBeChildOfComponentName : function(){
            return true;
        }
    },
    {
        getDefaultStyle : function(){
            return {
                padding : '0',
                margin : '0'
            };
        },

        getDefaultData : function(){
            return {
                "btnBgColor_$$comment" : '按钮颜色',
                btnBgColor : '#ecd195',
                "btnTextColor_$$comment" : '按钮文字颜色',
                btnTextColor : '#9d6f3b',
                "btnText_$$comment" : '按钮文案',
                btnText : '立即邀请好友',
                "title_$$comment" : '分享的标题',
                title: '这有880元红包和200元生鲜卡送你！',
                "desc_$$comment" : '分享的文案',
                desc : '新手专享10%扣费后年利率，人人贷七年老平台，专业可信赖！',
                "link_$$comment" : '分享跳转的链接',
                link : "https://m.renrendai.com/mo/pb/cv1/page/pageId/59c0928485c66d1e7bad032b",
                "imgUrl_$$comment" : '分享的logo',
                imgUrl : "https://m.we.com/cms/58647d50e0286a10854d875a/invite/share/rShare2.jpg",
                "shortMessage_$$comment" : '短信分享的文案',
                shortMessage : "戳 https://m.renrendai.com/mo/pb/cv1/page/pageId/59c0928485c66d1e7bad032b 注册领红包"

            };
        },

        init : function(){
            //当前Ajax请求的ID
            this.querySign = null;
            //是否已经绑定了组件自定义事件
            this.eventBinded = false;
        },

        render : function(){

            let currentComponentId = this.componentId;
            let data = this.data;

            let cssClass = this.getBaseCssClass() + '  ';
            let cssStyle = this.translateStyle( this.style );
            let $el = $(tpl).addClass( cssClass ).css( cssStyle );;
            let $content = $('.glpb-content', $el);

            this.$el = $el;
            this.$content = $content;

            if( ! this.isProductionMode() ){
                //编辑模式, 显示一个图片占位
                $(`<img class="editor-place-holder-img" src="${editorPlaceHolderImage}" title="分享按钮占位图片(非真实数据)" />`).appendTo( $content );
            }
        },

        bindComponentEvent : function(){

            let that = this;
            let configData = this.data || {};


            if( this.isProductionMode() && ! this.eventBinded ){

                this.eventBinded = true;

                lpService.pbShareCode( {} ).then( ( reqResult ) => {
                    if( reqResult.requestStatus === lpService.STATUS.SUCCESS ){
                        let result = reqResult.data;
                        if( result.status === 0 ){
                            that.renderShareDom(result.data ,configData);

                            console.log(result.data);
                            return;
                        }
                        return Promise.reject(new Error(result.message));
                    }
                    return Promise.reject( new Error('获取shareCode据异常!'));
                })
                .catch( (e) => {
                    console.log(e);
                    alert(e.message);
                });
            }
        },

        renderShareDom : function(data,configData){
            //微信必要的初始化
            bridgeXXX.init();

            let  btnBgColor = configData.btnBgColor;
            let  btnTextColor = configData.btnTextColor;
            let  btnText = configData.btnText;

            //获取到登录状态和share_id
            let  isLogin = data.isLogin;
            let  share_id = data.shareCode ? data.shareCode:'';
            //组装shareData
            let shareLink = configData.link;
            if(share_id){
                share_id = encodeURIComponent(share_id);
            }
            if(isLogin){
                shareLink += `?share_id=${share_id}&utm_source=mgm`;
            }
            shareData = {
                 title : configData.title,
                 desc: configData.desc,
                 link: shareLink,
                 img_url:configData.imgUrl,
                 imgUrl: configData.imgUrl,
                 shortMessage: configData.shortMessage
            }

            initShare();

            //异步处理短链
            lpService.pbShortUrl( {  longUrl : shareLink} ).then( ( reqResult ) => {
                if( reqResult.requestStatus === lpService.STATUS.SUCCESS ){
                    let result = reqResult.data;
                    if( result.status === 0 ){
                        let shortUrl = result.data.shortUrl;
                        shareData.shortMessage = `戳 ${shortUrl} 注册领红包`;
                        return;
                    }
                    return Promise.reject(new Error(result.message));
                }
                return Promise.reject( new Error('获取短链异常!'));
            })
            .catch( (e) => {
                console.log(e);
                alert(e.message);
            });



            let html = `
            <div class="wx-share-btn" style="background:${btnBgColor}; color:${btnTextColor}">${btnText}</div>
            <div class="modal-box fn-hide">
                <div class="modal-bg fn-hide"></div>
                <div class="share-modal fn-hide" id="wx-share">
                    <img class="share_bg" src="//m.renrendai.com/cms/58660a17cb02a3105bff2da1/activity/magpieFestival/share-img.png?t=20170822-02" alt="点击右上角分享">
                </div>
            </div>
            `;


            if( html ) {

                this.$content.html(html);

                this.$content.on('click', ()=>{
                    toShare(isLogin);
                } );
            }
        },


        componentWillUnmount : function(){
            if( this.eventBinded ){
                this.$content.off('click', toShare );
            }
            this.$content = null;
        }

    }
);


module.exports = MgmShareBtn;
