/**
 * 维护所有的service的工厂
 * Created by 王半仙 on 16/6/13.
 */





const passportService = require('./sub/passport-service');
const utilService = require('./sub/util-service');

const fundService = require('./sub/fund-service.js');
const exchangeService = require('./sub/exchange-service.js');
const fofService = require('./sub/fof-service.js');
const currentService = require('./sub/current-service.js');
const lpService = require('./sub/lp-service.js');

let serviceMap = {
    passport : passportService,
    util : utilService,
    fund : fundService,
    exchange : exchangeService,
    fof:fofService,
    current:currentService,
    lp:lpService

};

let singleton = {

    getService : function(name){
        return serviceMap[name];
    }

};



module.exports = singleton;