/**
 * lp相关的异步接口
 * Created by qiangran on 16/12/15.
 */

const ServiceBase = require('./../service-base');


const adapters = {};

const MOBILE_URL_PREFIX = '/mo';

const apiConf = {
    /*  注册接口 迁移至user-web 2019-01-02 */
    doRegister: {
        url: '/mo/lp/lp/doRegister',
        method: 'POST',
        dataType: 'json'
    },
    /* 注册 获取手机验证码 */
    register: {
        url: `${MOBILE_URL_PREFIX}/lp/lp/postRegister`,
        method: 'POST',
        dataType: 'json'
    },
    // 获取手机验证码 老mobile接口
    smsCode: {
        url: `${MOBILE_URL_PREFIX}/lp/lp/getPhoneSmsCode`,
        method: 'POST',
        dataType: 'json'

    },
    // 获取手机验证码 迁移Node接口
    sendRegisterSms: {
        url: `${MOBILE_URL_PREFIX}/passport/index/sendSmsOnlyGeetest`,
        method: 'POST',
        dataType: 'json'
    },
    // 获取手机验证码 【不输入密码】
    sendRegisterSms4NoPassword: {
        url: `${MOBILE_URL_PREFIX}/passport/index/sendSms4NoPassword`,
        method: 'POST',
        dataType: 'json'
    },
    // 注册提交接口
    doRegister4NoPassword: {
        url: '/mo/lp/lp/doRegister4NoPassword',
        method: 'POST',
        dataType: 'json'
    },

    // 校验手机验证码
    verifySmsCode: {
        url: `${MOBILE_URL_PREFIX}/lp/lp/verifyPhoneSmsCode`,
        method: 'GET',
        dataType: 'json'

    },
    // U新
    newerInvest: {
        url: `${MOBILE_URL_PREFIX}/lp/lp/getNewer`,
        method: 'GET',
        dataType: 'json'
    },
    // 优选计划
    premiumInvest: {
        url: `${MOBILE_URL_PREFIX}/pb/plan/premium`,
        method: 'GET',
        dataType: 'json'
    },
    //U享
    uplan:{
        url: `${MOBILE_URL_PREFIX}/pb/plan/uplan`,
        method: 'GET',
        dataType: 'json'
    },
    // 统计数据
    pbStatistic: {
        url: `${MOBILE_URL_PREFIX}/lp/lp/pbStatistic`,
        method: 'GET',
        dataType: 'json'
    },
    // 分享的shareCode
    pbShareCode: {
        url: `${MOBILE_URL_PREFIX}/user/invite/pbShareCode`,
        method: 'GET',
        dataType: 'json'
    },
    // 获取短链
    pbShortUrl: {
        url: `${MOBILE_URL_PREFIX}/about/media/getShortUrl`,
        method: 'GET',
        dataType: 'json'
    },
    // 获取邀请人信息
    pbInviterInfo: {
        url: `${MOBILE_URL_PREFIX}/user/invite/pbGetUserInfoByShareCode`,
        method: 'GET',
        dataType: 'json'
    },
    // 获取邀请人现金奖励(7月MGM)
    pbInviterCash: {
        url: `${MOBILE_URL_PREFIX}/user/invite/pbGetUserCashRewardByShareCode`,
        method: 'GET',
        dataType: 'json'
    },
    // 获取手机短信验证码
    sendDeepKnowRegisterCode: {
        url: `${MOBILE_URL_PREFIX}/passport/index/sendDeepKnowRegisterCode`,
        method: 'POST',
        dataType: 'json'

    },
    //深知的验证
    deepKnowValidate:{
        url:`${MOBILE_URL_PREFIX}/passport/index/deepKnowValidate`,
        method:'POST',
        dataType : 'json'
    },
    //直接发送短信验证  或者图形验证发送短信验证码
    captchaSendSmsCode:{
        url:`${MOBILE_URL_PREFIX}/passport/index/captchaSendSmsCode`,
        method:'POST',
        dataType : 'json'
    },
    //出借风险提示弹窗cms开关
    riskSwitchStatus: {
        url: `${MOBILE_URL_PREFIX}/agreement/risk/riskSwitchStatus`,
        method: 'GET',
        dataType: 'json'
    },
    //风险提示弹窗内容
    riskContentStatus: {
        url: `${MOBILE_URL_PREFIX}/agreement/risk/riskContent`,
        method: 'GET',
        dataType: 'json'
    },
    //获取极验配置
    geetestConfig: {
        url: `${MOBILE_URL_PREFIX}/passport/index/geetestConfig`,
        method: 'GET',
        dataType: 'json'
    },
    //出借滚动条组件数据
    getScrollBarData:{
        url: `${MOBILE_URL_PREFIX}/lp/lp/getScrollBarData`,
        method: 'GET',
        dataType: 'json'
    }
};


let utilService = new ServiceBase( apiConf, adapters);

module.exports = utilService;
